Index: chan_sip.c
===================================================================
RCS file: /usr/cvsroot/asterisk/channels/chan_sip.c,v
retrieving revision 1.869
diff -u -r1.869 chan_sip.c
--- chan_sip.c	28 Sep 2005 04:08:57 -0000	1.869
+++ chan_sip.c	28 Sep 2005 20:45:29 -0000
@@ -653,6 +653,8 @@
 	int stateid;
 	int laststate;                          /* Last known extension state */
 	int dialogver;
+
+	int noncecount;				/* Count of nonce's.  Increment by 1 for each use. */
 	
 	struct ast_dsp *vad;			/* Voice Activation Detection dsp */
 	
@@ -5327,6 +5329,8 @@
 		if (sipdebug)
 			ast_log(LOG_DEBUG, "   >>> Re-using Auth data for %s@%s\n", r->username, r->hostname);
 		ast_copy_string(p->realm, r->realm, sizeof(p->realm));
+		if ( !strcmp(p->nonce, r->nonce) )	/* Got a new nonce */
+			p->noncecount = 0;
 		ast_copy_string(p->nonce, r->nonce, sizeof(p->nonce));
 		ast_copy_string(p->domain, r->domain, sizeof(p->domain));
 		ast_copy_string(p->opaque, r->opaque, sizeof(p->opaque));
@@ -5462,9 +5466,10 @@
 		char digest[1024];
 
 		memset(digest, 0, sizeof(digest));
-		if(!build_reply_digest(p, sipmethod, digest, sizeof(digest)))
+		if(!build_reply_digest(p, sipmethod, digest, sizeof(digest))) {
 			add_header(&resp, "Proxy-Authorization", digest);
-		else
+			add_header(&resp, "Authorization", digest);
+		} else
 			ast_log(LOG_WARNING, "No authentication available for call %s\n", p->callid);
 	}
 	/* If we are hanging up and know a cause for that, send it in clear text to make
@@ -8830,6 +8835,8 @@
 	char *md5secret;
 	struct sip_auth *auth = (struct sip_auth *) NULL;	/* Realm authentication */
 
+	p->noncecount++;	/* Increment each use */
+
 	if (!ast_strlen_zero(p->domain))
 		ast_copy_string(uri, p->domain, sizeof(uri));
 	else if (!ast_strlen_zero(p->uri))
@@ -8867,13 +8874,13 @@
 	/* XXX We hard code the nonce-number to 1... What are the odds? Are we seriously going to keep
 	       track of every nonce we've seen? Also we hard code to "auth"...  XXX */
 	if (!ast_strlen_zero(p->qop))
-		snprintf(resp,sizeof(resp),"%s:%s:%s:%s:%s:%s", a1_hash, p->nonce, "00000001", cnonce, "auth", a2_hash);
+		snprintf(resp,sizeof(resp),"%s:%s:%08d:%s:%s:%s", a1_hash, p->nonce, p->noncecount, cnonce, "auth", a2_hash);
 	else
 		snprintf(resp,sizeof(resp),"%s:%s:%s", a1_hash, p->nonce, a2_hash);
 	ast_md5_hash(resp_hash, resp);
 	/* XXX We hard code our qop to "auth" for now.  XXX */
 	if (!ast_strlen_zero(p->qop))
-		snprintf(digest, digest_len, "Digest username=\"%s\", realm=\"%s\", algorithm=MD5, uri=\"%s\", nonce=\"%s\", response=\"%s\", opaque=\"%s\", qop=auth, cnonce=\"%s\", nc=00000001", username, p->realm, uri, p->nonce, resp_hash, p->opaque, cnonce);
+		snprintf(digest, digest_len, "Digest username=\"%s\", realm=\"%s\", algorithm=MD5, uri=\"%s\", nonce=\"%s\", response=\"%s\", opaque=\"%s\", qop=auth, cnonce=\"%s\", nc=%08d", username, p->realm, uri, p->nonce, resp_hash, p->opaque, cnonce, p->noncecount);
 	else
 		snprintf(digest, digest_len, "Digest username=\"%s\", realm=\"%s\", algorithm=MD5, uri=\"%s\", nonce=\"%s\", response=\"%s\", opaque=\"%s\"", username, p->realm, uri, p->nonce, resp_hash, p->opaque);
 
